/*
 *
 *  TCP/IP 饤֥
 *
 *  Copyright 1995-1996 Matsushita Soft Research, INC. A.Takuma
 *
 *  System      : NNTP/SMTP/POP3 library
 *  Sub system  : TCP/IP library
 *  File        : tcplib.c
 *  Version     : 0.40
 *  First Edit  : 1995-12/25
 *  Last  Edit  : 1996-12/03
 *  Author      : MSR24  
 *
 */

#include	"compat.h"
#include	"tcplib.h"
#ifdef	MNEWS
#include	"nntplib.h"
#include	"field.h"
#include	"mnews.h"
#endif	/* MNEWS */

char		auth_file[PATH_BUFF] = "";	/* 桼ǧڥե	*/

#if	defined(NNTP) || defined(SMTP) || defined(POP3)
/*
 * TCP/IP 
 */

#ifdef	MSDOS
int	tcp_send(service_name, read_pfd, write_pfd, string)
     char	*service_name;
     int	*read_pfd;
     int	*write_pfd;
     char	*string;
{
#ifdef	MSDOS
  char		buff[BUFF_SIZE];
#endif	/* MSDOS */

#ifdef	MSDOS
  if (*write_pfd == -1) {
#else	/* !MSDOS */
  if (write_fp == (FILE*)NULL) {
#endif	/* !MSDOS */
    print_fatal("%s write stream not ready.", service_name);
    return(1);
  }
#ifdef	TCP_DEBUG
  fprintf(stderr, "SEND:%s\n", string);
#endif	/* TCP_DEBUG */

  /*
   * DECstation Ǥ setenv PROG_ENV POSIX  compile ʤ
   * printf ͤ 0 ʤΤǤޤưޤ
   */

#ifdef	MSDOS
  sprintf(buff, "%s\r\n", string);
  if (send(*write_pfd, buff, strlen(buff), 0) > 0) {
    return(0);
  }
#else	/* !MSDOS */
  if (fprintf2(write_fp, "%s\r\n", string) == (strlen(string) + 2)) {
    if (!fflush(write_fp)) {
      return(0);
    }
  }
#endif	/* !MSDOS */
  print_fatal("%s connection closed.", service_name);
#ifdef	MSDOS
  closesocket(*write_pfd);
  *read_pfd = *write_pfd = -1;
#else	/* !MSDOS */
  if (write_fp != (FILE*)NULL) {
    fclose(write_fp);
    write_fp = (FILE*)NULL;
  }
  if (read_fp != (FILE*)NULL) {
    fclose(read_fp);
    read_fp = (FILE*)NULL;
  }
#endif	/* !MSDOS */
  return(1);
}
#else	/* !MSDOS */
int	tcp_send(service_name, read_pfp, write_pfp, string)
  char	*service_name;
  FILE	**read_pfp;
  FILE	**write_pfp;
  char	*string;
{
#ifdef	MSDOS
  char		buff[BUFF_SIZE];
#endif	/* MSDOS */

#ifdef	MSDOS
  if (write_fd == -1) {
#else	/* !MSDOS */
  if (*write_pfp == (FILE*)NULL) {
#endif	/* !MSDOS */
    print_fatal("%s write stream not ready.", service_name);
    return(1);
  }
#ifdef	TCP_DEBUG
  fprintf(stderr, "SEND:%s\n", string);
#endif	/* TCP_DEBUG */

  /*
   * DECstation Ǥ setenv PROG_ENV POSIX  compile ʤ
   * printf ͤ 0 ʤΤǤޤưޤ
   */

#ifdef	MSDOS
  sprintf(buff, "%s\r\n", string);
  if (send(write_fd, buff, strlen(buff), 0) > 0) {
    return(0);
  }
#else	/* !MSDOS */
  if (fprintf2(*write_pfp, "%s\r\n", string) == (strlen(string) + 2)) {
    if (!fflush(*write_pfp)) {
      return(0);
    }
  }
#endif	/* !MSDOS */
  print_fatal("%s connection closed.", service_name);
#ifdef	MSDOS
  closesocket(write_fd);
  read_fd = write_fd = -1;
#else	/* !MSDOS */
  if (*write_pfp != (FILE*)NULL) {
    fclose(*write_pfp);
    *write_pfp = (FILE*)NULL;
  }
  if (*read_pfp != (FILE*)NULL) {
    fclose(*read_pfp);
    *read_pfp = (FILE*)NULL;
  }
#endif	/* !MSDOS */
  return(1);
}
#endif	/* !MSDOS */

/*
 * TCP/IP 
 */

#ifdef	MSDOS
int	tcp_receive(service_name, read_pfd, write_pfd, ptr, size)
  char	*service_name;
  int	*read_pfd;
  int	*write_pfd;
  char	*ptr;
  int	size;
{
  static char		*ptr2;
  static char		read_buff[BUFF_SIZE];
  static int		count = 0;
  char			c;
  
  if (*read_pfd == -1) {
    print_fatal("%s read stream not ready.", service_name);
    return(1);
  }
  while (1) {
    if (count <= 0) {
#ifdef	INETBIOS
      count = _recv(*read_pfd, read_buff, sizeof(read_buff), 0);
#else	/* !INETBIOS */
      count = recv(*read_pfd, read_buff, sizeof(read_buff), 0);
#endif	/* !INETBIOS */
      ptr2 = read_buff;
      if (count <= 0) {
	print_fatal("%s connection closed.", service_name);
	closesocket(*write_pfd);
	*read_pfd = *write_pfd = -1;
	return(1);
      }
    }
    while (count--) {
      c = *ptr2++;
      if (c == '\n') {
        goto done;
      }
      if (c != '\r') {
	*ptr++ = c;
	if (--size == 0) {
	  goto done;
	}
      }
    }
  }
done:
  *ptr = '\0';
#ifdef	TCP_DEBUG
  fprintf(stderr, "RECEIVE:%s\n", ptr);
#endif	/* TCP_DEBUG */
  return(0);
}
#else	/* !MSDOS */
int	tcp_receive(service_name, read_pfp, write_pfp, ptr, size)
     char	*service_name;
     FILE	**read_pfp;
     FILE	**write_pfp;
     char	*ptr;
     int	size;
{
  register char		*ptr2;
  
  if (*read_pfp == (FILE*)NULL) {
    print_fatal("%s read stream not ready.", service_name);
    return(1);
  }
  if (!fgets(ptr, size, *read_pfp)) {
    print_fatal("%s connection closed.", service_name);
    if (*write_pfp != (FILE*)NULL) {
      fclose(*write_pfp);
      *write_pfp = (FILE*)NULL;
    }
    if (*read_pfp != (FILE*)NULL) {
      fclose(*read_pfp);
      *read_pfp = (FILE*)NULL;
    }
    return(1);
  }
  if (ptr2 = strchr(ptr, '\r')) {
    *ptr2 = '\0';
  } else if (ptr2 = strchr(ptr, '\n')) {
    *ptr2 = '\0';
  }
#ifdef	TCP_DEBUG
  fprintf(stderr, "RECEIVE:%s\n", ptr);
#endif	/* TCP_DEBUG */
  return(0);
}
#endif	/* !MSDOS */

/*
 * TCP åȼ
 */

int	get_tcp_socket(server_name, service_name, protocol_name,
		       port_number, default_port)
     char		*server_name;
     char		*service_name;
     char		*protocol_name;
     unsigned int	port_number;
     int		default_port;
{
#ifndef	MSDOS
#ifdef	notdef
  struct hostent	host_data;
#endif	/* notdef */
#endif	/* !MSDOS */
  struct hostent	*host_ent;
  struct sockaddr_in	sock_in;
  struct servent	*serv_ent;
  int			port;
  int			s;
  int			x;
#ifdef	h_addr
  register char		**pptr;
  unsigned char		*inet_adrs_ptr;
#ifdef	notdef
  char			*alias_list[1];
#endif	/* notdef */
#endif	/* h_addr */

  if (default_port < 0) {
    port = IPPORT_RESERVED - 1;
  } else {
    if (port_number > 0) {
      port = htons(port_number);
    } else {
      if (serv_ent = getservbyname(protocol_name, "tcp")) {
	port = serv_ent->s_port;
      } else {
	if (default_port >= 0) {
	  print_warning("Can't get \"%s\" port,use default.", protocol_name);
	  port = htons(default_port);
	} else {
	  print_fatal("Can't get \"%s\" port.", protocol_name);
	  return(-1);
	}
      }
    }
  }
  if (!isdigit(*server_name)) {			/* ̾	*/
    host_ent = gethostbyname(server_name);
  } else {					/* IP ɥ쥹	*/
#ifdef	MSDOS
    print_fatal("%s server can't use IP-address.", service_name);
    return(-1);
#else	/* !MSDOS */
    if ((sock_in.sin_addr.s_addr = inet_addr(server_name)) == -1) {
      print_fatal("Illegal IP address \"%s\".", server_name);
      return(-1);
    }
#ifdef	notdef
    host_data.h_name      = server_name;
#ifdef	h_addr
    host_data.h_addr_list = alias_list;
#endif	/* h_addr */
    host_data.h_addr      = (char*)&sock_in.sin_addr;
    host_data.h_length    = sizeof(struct in_addr);
    host_data.h_addrtype  = AF_INET;
    host_data.h_aliases   = 0;
    host_ent              = &host_data;
#else	/* !notdef */
    host_ent = gethostbyaddr((char*)&sock_in.sin_addr,
			     sizeof(sock_in.sin_addr), AF_INET);
#endif	/* !notdef */
#endif	/* !MSDOS */  
  }
  if (!host_ent) {
    print_fatal("Unknown %s server \"%s\".", service_name, server_name);
    return(-1);
  }
  
  bzero((char*)&sock_in, sizeof(sock_in));
  sock_in.sin_family = host_ent->h_addrtype;

  print_warning("Trying connect %s.", server_name);
  s = x = -1;
  while (1) {
#ifdef	MSDOS
    sock_in.sin_port = htons(port);
#else	/* MSDOS */
    sock_in.sin_port = port;
#endif	/* !MSDOS */
#ifdef	h_addr
    for (pptr = host_ent->h_addr_list; pptr && *pptr; pptr++) {
      s = socket(host_ent->h_addrtype, SOCK_STREAM, 0);
      if (s < 0) {
	print_fatal("Can't open socket.");
	return(-1);
      }
      bcopy(*pptr, (char*)&sock_in.sin_addr, host_ent->h_length);
      inet_adrs_ptr = (unsigned char*)&sock_in.sin_addr;
#ifdef	notdef
      if (x < 0) {
	print_warning("Trying %d.%d.%d.%d",
		      inet_adrs_ptr[0], inet_adrs_ptr[1],
		      inet_adrs_ptr[2], inet_adrs_ptr[3]);
      }
#endif	/* notdef */
      x = connect(s, (struct sockaddr*)&sock_in, sizeof(sock_in));
      if (!x) {
	break;
      }
#ifdef	notdef
      print_warning("Connection to %d.%d.%d.%d",
		    inet_adrs_ptr[0], inet_adrs_ptr[1],
		    inet_adrs_ptr[2], inet_adrs_ptr[3]);
#endif	/* notdef */
      (void)close(s);
    }
#else	/* !h_addr */
#ifdef EXCELAN
    if ((s = socket(SOCK_STREAM,(struct sockproto*)NULL, &sock_in,
		    SO_KEEPALIVE)) < 0) {
      print_fatal("Can't open socket.");
      return(-1);
    }
    bzero((char*)&sock_in, sizeof(sock_in));
    sock_in.sin_family = AF_INET;
    sock_in.sin_port   = htons(port);
    
    if ((sock_in.sin_addr.s_addr = rhost(&server_name)) == -1) {
      print_fatal("Unknown %s server \"%s\".", service_name, server_name);
      return(-1);
    }
    x = connect(s, (struct sockaddr*)&sock_in);
#else /* !EXCELAN */
#ifdef	MSDOS
    if ((s = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) < 0) {
      print_fatal("Can't open socket.");
      return(-1);
    }
#else	/* !MSDOS */
    if ((s = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
      print_fatal("Can't open socket.");
      return(-1);
    }
#endif	/* !MSDOS */
#ifdef	INETBIOS
    sock_in.sin_addr.s_addr = host_ent->h_addr;
    x = connect(s, (struct sockaddr_in*)&sock_in, sizeof(sock_in));
#else	/* !INETBIOS */
    bcopy(host_ent->h_addr, (char*)&sock_in.sin_addr, host_ent->h_length);
    x = connect(s, (struct sockaddr*)&sock_in, sizeof(sock_in));
#endif	/* !INETBIOS */
#endif	/* !EXCELAN */
#endif	/* !h_addr */
    if (default_port < 0) {
      if (port > (IPPORT_RESERVED / 2)) {
	port--;
      } else {
	break;
      }
    } else {
      break;
    }
  }
  if (x < 0) {
    print_fatal("Can't connect %s server \"%s\".", service_name, server_name);
    if (s >= 0) {
      (void)close(s);
    }
    return(-1);
  }
  return(s);
}

/*
 * ǥեȥ̾
 */

int	get_default_server(filename, server_name, env_name, port_ptr)
  char		*filename;
  char		*server_name;
  char		*env_name;
  unsigned int	*port_ptr;
{
  FILE		*fp;
  register char	*ptr1, *ptr2;
  char		buff[BUFF_SIZE];
  
  if (ptr1 = (char*)getenv(env_name)) {
    strcpy(server_name, ptr1);
    ptr2 = strchr(server_name, ':');
    if (ptr2 != (char*)NULL) {
      *ptr2++ = '\0';
      if (atoi(ptr2) > 0) {
	*port_ptr = atoi(ptr2) & 0xFFFF;
      }
    }
    return(0);
  }
  if (!filename) {
    return(1);
  }
  if (!*filename) {
    return(1);
  }
  if ((fp = fopen(filename, "r")) == (FILE*)NULL) {
    return(1);
  }
  while (fgets(buff, sizeof(buff), fp)) {
    ptr1 = buff;
    while ((*ptr1 == '\t') || (*ptr1 == ' ')) {
      ptr1++;
    }
    ptr2 = ptr1;
    if ((*ptr1 == '\n') || (*ptr1 == '#')) {
      continue;
    }
    ptr1 = strchr(ptr1, '\n');
    if (ptr1) {
      *ptr1 = '\0';
    }
    fclose(fp);
    strcpy(server_name, ptr2);
    return(0);
  }
  fclose(fp);
  return(1);			 /* No entry */
}

/*
 * 桼/ѥɼ
 */

int	get_user_pass(server_name, user_ptr, pass_ptr)
     char	*server_name;
     char	*user_ptr;
     char	*pass_ptr;
{
  FILE			*fp;
  register char		*ptr1, *ptr2;
  struct hostent	*server_entry;
  char			buff[BUFF_SIZE];
  int			status;
#ifndef	MNEWS
#ifdef	MSDOS
  char			*env_ptr;
#else	/* !MSDOS */
  struct passwd		*passwd;
#endif	/* !MSDOS */
#endif	/* !MNEWS */

  *user_ptr = '\0';
  if (pass_ptr != (char*)NULL) {
    *pass_ptr = '\0';
  }
#ifdef	MNEWS
  strcpy(user_ptr, user_name);
#else	/* !MNEWS */
#ifdef	MSDOS
  if (env_ptr = (char*)getenv("USER")) {
    strcpy(user_ptr, env_ptr);
  } else {
    return(1);
  }
#else	/* !MSDOS */
  if (passwd = (struct passwd*)getpwuid(geteuid())) {
    strcpy(user_ptr, passwd->pw_name);
  } else {
    return(1);
  }
#endif	/* !MSDOS */
#endif	/* !MNEWS */
  if (!auth_file[0]) {
    return(1);
  }
  if (pass_ptr == (char*)NULL) {
    return(0);
  }
  if ((fp = fopen(auth_file, "r")) == (FILE*)NULL) {
#ifdef	MNEWS
    strcpy(buff, user_ptr);
    input_line(INPUT_SPCCUT_MASK ,"桼̾ϤƲ:",
	       "Input user name :" , buff);
    if (!buff[0]) {
      *user_ptr = '\0';
      return(1);
    }
    strcpy(user_ptr, buff);
    buff[0] = '\0';
    input_line(INPUT_SPCCUT_MASK | INPUT_SHADOW_MASK,
	       "ѥɤϤƲ:",
	       "Input password :", buff);
    strcpy(pass_ptr, buff);
#else	/* !MNEWS */
#endif	/* !MNEWS */
    return(0);
  }
  status = 1;
  while (fgets(buff, sizeof(buff), fp)) {
    ptr1 = buff;
    while ((*ptr1 == '\t') || (*ptr1 == ' ')) {
      ptr1++;
    }
    if ((*ptr1 == '\n') || (*ptr1 == '#')) {
      continue;
    }
    if ((ptr2 = strchr(ptr1, '\n'))) {
      *ptr2 = '\0';
    }
    for (ptr2 = ptr1; *ptr2 && (*ptr2 != '\t') && (*ptr2 != ' '); ptr2++);
    if (!*ptr2) {
      continue;
    }
    *ptr2++ = '\0';
    if (!(server_entry = gethostbyname(ptr1))) {
      continue;
    }
    if (!strcmp(server_entry->h_name, server_name)) {
      while ((*ptr2 == '\t') || (*ptr2 == ' ')) {
	ptr2++;
      }
      if ((!*ptr2) || (*ptr2 == '#')) {
	continue;
      }
      strcpy(pass_ptr, ptr2);
      status = 0;
      break;
    }
  }
  fclose(fp);
  return(status);
}
#endif	/* (NNTP || SMTP || POP3) */

#if	!(defined(MNEWS) || defined(MAKEKIN))
/*
 * ٹ𥨥顼ɽ
 */

#ifdef	DONT_HAVE_DOPRNT
void	print_warning(fmt, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8)
     char	*fmt;
     int	arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8;
{
  char		buff[SMALL_BUFF];

  if (!quiet_mode) {
    sprintf(buff, fmt, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8);
    fprintf(stderr, "%s : Warning : %s\n", prog_name, buff);
    fflush(stderr);
  }
}
#else	/* !DONT_HAVE_DOPRNT */
#ifdef	__STDC__
void	print_warning(char *fmt, ...)
#else	/* !__STDC__ */
void	print_warning(fmt, va_alist)
     char	*fmt;
#endif	/* !__STDC__ */
{
  va_list	ap;
  char		buff[SMALL_BUFF];

#ifdef	__STDC__
  va_start(ap, fmt);
#else	/* !__STDC__ */
  va_start(ap);
#endif	/* !__STDC__ */
  vsprintf(buff, fmt, ap);
  if (!quiet_mode) {
    fprintf(stderr, "%s : Warning : %s\n", prog_name, buff);
    fflush(stderr);
  }
  va_end(ap);
}
#endif	/* !DONT_HAVE_DOPRNT */

/*
 * ̿Ū顼ɽ
 */

#ifdef	DONT_HAVE_DOPRNT
void	print_fatal(fmt, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8)

     char	*fmt;
     int	arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8;
{
  char		buff[SMALL_BUFF];

  if (quiet_mode < 2) {
    sprintf(buff, fmt, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8);
    fprintf(stderr, "%s : %s\n", prog_name, buff);
    fflush(stderr);
  }
}
#else	/* !DONT_HAVE_DOPRNT */
#ifdef	__STDC__
void	print_fatal(char *fmt, ...)
#else	/* !__STDC__ */
void	print_fatal(fmt, va_alist)
     char	*fmt;
#endif	/* !__STDC__ */
{
  va_list	ap;
  char		buff[SMALL_BUFF];

#ifdef	__STDC__
  va_start(ap, fmt);
#else	/* !__STDC__ */
  va_start(ap);
#endif	/* !__STDC__ */
  vsprintf(buff, fmt, ap);
  if (quiet_mode < 2) {
    fprintf(stderr, "%s : %s\n", prog_name, buff);
    fflush(stderr);
  }
  va_end(ap);
}
#endif	/* !DONT_HAVE_DOPRNT */
#endif	/* !(MNEWS || MANEKIN) */
